#!/bin/bash

set -euo pipefail

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"

PROJECT="dropshell-build-base"
ARCH=$(uname -m)

echo "Building ${PROJECT} for ${ARCH}..."

# Build multi-platform image and push it
docker build \
  -t "${PROJECT}:test" \
  -f "${SCRIPT_DIR}/Dockerfile.${PROJECT}" \
  "${SCRIPT_DIR}"

echo "Successfully built ${PROJECT}:test"
