#!/bin/bash

set -euo pipefail

# check standard variables present.
#[[ -n $SOS_WRITE_TOKEN ]] || die "SOS_WRITE_TOKEN not specified"
#[[ -n $DOCKER_PUSH_TOKEN ]] || die "DOCKER_PUSH_TOKEN not specified"

ARCH=$(uname -m)

echo "Publishing dropshell-build-base:test as :latest-${ARCH}..."

docker tag dropshell-build-base:test gitea.jde.nz/public/dropshell-build-base:latest-${ARCH}
docker push gitea.jde.nz/public/dropshell-build-base:latest-${ARCH}

echo "Successfully pushed dropshell-build-base:latest-${ARCH}"


